#include <stdio.h>
#include <math.h>
/* ruffini.c : file sorgente di un programma che risolve un'equazione
               polinomiale a coefficienti interi con il metodo di
	       Ruffini. */
/* ### */
/* La prossima definizione consente di cambiare facilmente il grado
   massimo che puo' assumere il polinomio P(x) (e quindi anche
   l'equazione polinomiale corrispondente P(x)=0). */
#define GRADOMAX 10
/* Definizione dei prototipi delle funzioni */
int cerca_soluzione_intera(int grado_pol, int vet_pol[], int *radice);
void dividi_polinomio(int *grado_pol, int vet_pol[], int radice);
int risolvi_eq(double a, double b, double c, double *x1, double *x2);
long int valuta_pol(int grado_pol, int vet_pol[], int x);
/* ### */
int main()
{
  int i, grado_pol, vet_pol[GRADOMAX+1], radice, flag;
  double a, b, c, x1, x2;
  /* Input della variabile grado_pol (cioe' il grado del polinomio) */ 


  printf("  -- Inizio inserimento dei coefficienti del polinomio P(x) --\n");
  /* Input di vet_pol[0] (cioe' del coefficiente relativo al termine
     x^0, che deve essere diverso da 0) */


  /* Eseguiamo il ciclo di istruzioni seguente per i compreso tra 1 e
     grado_pol-1 */

  {
    /* Input di vet_pol[i] (cioe' del coefficiente relativo al termine
       x^i) */


  }
  printf("Il coefficiente intero relativo al termine x^%d ", grado_pol);
  printf("e' automaticamente\ndefinito uguale a 1, perche' questo e' ");
  printf("il caso in cui la\nregola del resto di Ruffini e' piu' semplice\n");
  vet_pol[grado_pol] = 1;
  printf("  -- Fine inserimento dei coefficienti del polinomio P(x) --\n");
  /* Eseguiamo il ciclo di istruzioni seguenti mentre sono verificate
     entrambe le condizioni:
     (1) il grado del polinomio deve essere maggiore o uguale a 1;
     (2) la chiamata alla funzione cerca_soluzione_intera restituisce
         un valore diverso da zero (significa che e' stata trovata
	 una soluzione intera) */

  {
    /* Scriviamo il valore della radice intera trovata
       dell'eq. P(x)=0 */

    /* Dividiamo il polinomio P(x) per (x-radice) in modo da porre di
       nuovo i coefficienti del polinomio quoziente nel vettore
       vet_pol (si tratta di fare un'opportuna chiamata alla funzione
       dividi_polinomio) */

  }
  /* Effettuiamo un test per verificare se il ciclo precedente si
     e' arrestato quando il polinomio e' di secondo grado ... */

  {
    /* ... Allora possiamo trovare altre radici (che non saranno
       intere), utilizzando il metodo di soluzione di un'equazione di
       secondo grado.  IL PEZZO DI PROGRAMMA CHE SI VEDE DA QUI ALLA
       FINE DEL main ALTRO NON E' CHE IL main DEL PROGRAMMA IN
       eq_grado_2.c (CHE SI TROVA ALL'INTERNO DEGLI ARCHIVI COMPRESSI
       aproffe0304.tgz e aproffe0304.zip) CON POCHISSIME VARIAZIONI */
    /* Poniamo i coefficienti a, b, c uguali rispettivamente a
       vet_pol[2], vet_pol[1] e vet_pol[0] (QUESTA E' L'UNICA VARIAZIONE
       SIGNIFICATIVA RISPETTO A eq_grado_2.c) */


    /* Risolviamo l'equazione di secondo grado, assegnando alle
       variabili x1 e x2 le soluzioni e a flag il valore 1, 0, -1
       a seconda del segno di b^2 - 4*a*c */
    flag = risolvi_eq(a, b, c, &x1, &x2);
    /* Distinguiamo i diversi casi con le istruzioni
       switch ... case ... case ... default ... 
       (potremmo farlo anche con
       if ... else if ... else if ... else ... */
    switch(flag) {
    case 1:
      /* Nel caso flag=1 scriviamo un messaggio che dica che ci sono due
	 soluzioni reali e distinte */
      printf("Esistono anche due soluzioni reali e distinte:\n");
      /* Stampiamo i valori di x1 e x2 */
      printf("  x1 = %lf ; x2 = %lf\n", x1, x2);
      /* Attenzione a non dimenticare l'istruzione break, altrimenti
	 vengono eseguite anche le istruzioni seguenti fino al carattere } */
      break;
    case 0:
      /* Nel caso flag=0 scriviamo un messaggio che dica che ci sono due
	 soluzioni reali coincidenti */
      printf("Esistono anche due soluzioni reali coincidenti:\n");
      /* Stampiamo il valore di x1 */
      printf("  x1 = x2 = %lf\n", x1);
      /* Attenzione a non dimenticare l'istruzione break, altrimenti
	 vengono eseguite anche le istruzioni seguenti fino al carattere } */
      break;
    default:
      /* Nel caso flag=-1 scriviamo un messaggio che dica che ci sono due
	 soluzioni complesse */
      printf("Esistono anche due soluzioni complesse:\n");
      /* Stampiamo le soluzioni nella forma x1 +- i*x2 */
      printf("  %lf +- i*%lf\n", x1, x2);
      /* Questo e' l'ultimo caso, quindi non e' necessaria l'istruzione
	 break */
    }
  }
  exit(0);
}
/* ### */
int cerca_soluzione_intera(grado_pol, vet_pol, radice)
     int grado_pol, vet_pol[], *radice;
{
  int i, imax, segno, x, nsol;
  /* Poniamo imax uguale al valore assoluto di vet_pol[0] */

  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 1 fino
     a imax */

  {
    /* Effettuiamo un test per verificare se i e' un divisore di imax ... */

    {
      /* ... Allora eseguiamo il ciclo di istruzioni seguenti quando
         la variabile segno assume i valori -1 e +1 */

      {
	/* Poniamo la variabile x uguale al prodotto di segno per i */

	/* Effettuiamo un test per verificare se P(x) e' uguale a zero
	   (si tratta di fare un'opportuna chiamata alla funzione
	   valuta_pol) ... */

	{
	  /* ... Allora e' stata trovata una soluzione dell'equazione
	     polinomiale e questa radice e' proprio x:
	     poniamo uguale a x il valore dell'intero che si trova
	     nell'indirizzo di memoria a cui si riferisce radice */

	  /* Usciamo dalla funzione restituendo il valore 1 (che
	     significa che e' stata trovata una soluzione) */

	}
      }
    }
  }
  /* Usciamo dalla funzione restituendo il valore 0 (che significa che
     non e' stata trovata alcuna soluzione) */

}
/* ### */
void dividi_polinomio(grado_pol, vet_pol, radice)
     int *grado_pol, vet_pol[], radice;
{
  int i, vet_pol_quoziente[GRADOMAX+1];
  /* Osservazione:
     in questa funzione, il vettore di interi vet_pol_quoziente
     gioca il ruolo della successione finita di coefficienti
     q_0,...,q_n del polinomio quoziente Q(x), cosi' come sono
     scritti nel testo del tema d'esame;
     all'inizio della funzione il vettore di interi vet_pol gioca
     il ruolo della successione finita di coefficienti p_0,...,p_n
     del polinomio P(x), cosi' come sono scritti nel testo del tema
     d'esame, invece, alla fine della funzione il vettore vet_pol
     indica i coefficienti del polinomio quoziente Q(x);
     il grado del polinomio P(x) (all'inizio della funzione) e
     di Q(x) (alla fine della funzione) e' dato da *grado_pol,
     quindi *grado_pol all'inizio della funzione gioca il
     ruolo di n e alla fine di n-1, cosi' come sono scritti nel testo
     del tema d'esame */
  /* Poniamo q_n uguale a p_n */

  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da n-1 a 0 */

  {
    /* Poniamo q_i uguale a p_i+radice*q_i+1 */

  }
  /* Se q_0 e' diverso da zero, stampiamo un messaggio di errore,
     perche' il metodo di calcolo ci assicura che se radice e' una
     soluzione allora q_0 deve essere uguale a zero */


  /* Decrementiamo di uno il grado del polinomio (in modo che ora sia
     uguale a n-1, cosi' com'e' scritto nel temaa d'esame) */

  /* Poniamo p_i uguale a q_i+1 per ogni i che va da 0 fino al
     grado del polinomio (cioe' n-1) */


}
/* ### */
int risolvi_eq(a, b, c, x1, x2)
     double a, b, c, *x1, *x2;
{
  /* QUESTA FUNZIONE E' ESATTAMENTE IDENTICA A QUELLA CHE SI TROVA IN
     eq_grado_2.c */
  int flag;
  double Delta;
  /* Poniamo Delta = b^2 - 4*a*c */
  Delta = b*b - 4.*a*c;
  /* Distinguiamo i diversi casi a seconda del segno di Delta */
  if(Delta > 0.) {
    /* Siamo nel caso delle due radici reali e distinte:
       calcoliamo x1 ... */
    *x1 = -0.5 * ( b + sqrt(Delta) ) / a;
    /* ... e x2 */
    *x2 = -0.5 * ( b - sqrt(Delta) ) / a;
    /* Ricordiamoci di inizializzare flag */
    flag = 1;
  }
  else if(Delta == 0.) {
    /* Siamo nel caso delle due radici reali coincidenti:
       calcoliamo x1 e x2 */
    *x1 = *x2 = -0.5 * b / a;
    /* Ricordiamoci di inizializzare flag */
    flag = 0;
  }
  else {
    /* Siamo nel caso delle due radici complesse:
       poniamo x1 uguale alla parte reale delle soluzioni ... */
    *x1 = -0.5 * b / a;
    /* ... e poniamo x2 uguale alla parte immaginaria delle soluzioni */
    *x2 = 0.5 * sqrt(-Delta) / a;
    /* Ricordiamoci di inizializzare flag */
    flag = -1;
  }
  /* Usciamo dalla funzione restituendo il valore di flag */
  return(flag);
}
/* ### */
long int valuta_pol(grado_pol, vet_pol, x)
     int grado_pol, vet_pol[], x;
{
  int i;
  long int potx, ris;
  /* Poniamo il risultato ris inizialmente uguale a 0 ... */

  /* ... e la variabile potx uguale a 1 */

  /* Eseguiamo il ciclo di istruzioni seguenti che i che va da 0
     fino al grado del polinomio */

  {
    /* Aggiungiamo a ris il contributo dato dal coefficiente
       vet_pol[i] moltiplicato per potx (che, rispettivamente, giocano
       il ruolo di p_i e di x^i, cosi' come sono scritti nel tema
       d'esame) */

    /* Moltiplichiamo per x la variabile potx */

  }
  /* Usciamo dalla funzione restituendo il risultato ris */

}
