#include <stdio.h>
/* err_max_polari.c : file sorgente di un programma che legge dal file
                      "polari.out" (il quale e' a sua volta preparato
                      preventivamente dall'esecuzione del programma in
                      polari.c) il numero di tests e gli errori nei
                      tests stessi, che sono stati effettuati a
                      proposito delle equazioni dell'ellisse e della
                      parabola in coordinate polari.

		      Il programma presente in questo file determina
		      gli errori massimi nei tests relativi
		      all'ellisse e alla parabola, e li stampa sul
		      video */
/* ### */
int main()
{
  int i, ntest;
  double err, errmax;
  FILE *ifp;
  /* Apriamo in modalita' di lettura il file di output che si chiama
     "polari.out", associamo a ifp l'indirizzo corrispondente al
     file */
  ifp = fopen("polari.out", "r");
  /* Leggiamo il numero di tests effettuati dal file "polari.out" */
  fscanf(ifp, "%3d", &ntest);
  printf("Errore massimo nel test sull'equazione dell'ellisse:\n");
  errmax = 0.;
  for(i=0; i<ntest; i++) {
    fscanf(ifp, "%le", &err);
    if(errmax < err)  errmax = err; 
  }
  printf("  %le\n", errmax);
  printf("Errore massimo nel test sull'equazione della parabola:\n");
  errmax = 0.;
  for(i=0; i<ntest; i++) {
    fscanf(ifp, "%le", &err);
    if(errmax < err)  errmax = err; 
  }
  printf("  %le\n", errmax);
  /* Chiudiamo il file "polari.out" */
  fclose(ifp);
  exit(0);
}
