#include <stdio.h>
/* inserisci_elenco.c : file sorgente di un programma che che legge
                        l'elenco degli studenti (con il loro login
                        name e il gruppo di appartenenza) dal file
                        "belelenco.dat".
                        Dopo aver ordinato l'elenco in ordine crescente
                        rispetto al login name, l'elenco viene
                        riscritto nel file "ordelenco.dat".
			L'ordinamento viene effettuato facendo un
			ciclo di riordinamenti per ogni nuovo elemento
			considerato, con lo stesso algoritmo gia'
			utilizzato nel programma in
			inserisci_vettore.c. */

/* QUESTO PROGRAMMA NON E' ALTRO CHE UNA "MISCELA" DEI PROGRAMMI IN
   ordina_elenco.c (CHE SI TROVA ALL'INTERNO DEGLI ARCHIVI COMPRESSI
   aproffe0304.tgz e aproffe0304.zip) E IN inserisci_vettore.c.
   PIU' PRECISAMENTE IL main DI QUESTO PROGRAMMA E' QUASI UGUALE A
   QUELLO IN ordina_elenco.c, INVECE LE ROUTINES NECESSARIE
   PER EFFETTUARE L'ORDINAMENTO SONO OTTENUTE CON PICCOLE VARIAZIONI
   DA QUELLE IN inserisci_vettore.c */

/* ### */
/* La prossima definizione consente di cambiare facilmente la
   lunghezza massima consentita dei nomi e dei cognomi */
#define LUNGMAX 25
/* La prossima definizione consente di cambiare facilmente il
   numero massimo degli studenti */
#define NMAXSTUD 100
/* Definizione dei prototipi delle funzioni */
void riordina(char elenco[][], int n);
void scambia_righe(char elenco[][], int riga1, int riga2);
int trova_dove_inserire(char elenco[][], int n);
/* ### */
int main()
{
  int i, n, nstud;
  /* Rispetto al programma in ordina_elenco.c non ci servono le
     variabili: iniz_chiave e lung_chiave (che servivano per cambiare
     il criterio di ordinamento; in questo programma si considera un
     solo ordinamento possibile: quello rispetto al login name) */
  char intestazione[3*LUNGMAX];
  char elenco[NMAXSTUD][3*LUNGMAX];
  FILE *ifp, *ofp;
  /* Apriamo il file di input "belelenco.dat" in lettura,
     associamo a ifp l'indirizzo corrispondente al file */
  ifp = fopen("belelenco.dat", "r");
  /* Leggiamo la prima riga di intestazione in cima al file di input */
  fgets(intestazione, 3*LUNGMAX, ifp);
  /* Inizializziamo la variabile nstud (che rappresenta il numero di
     studenti) uguale a 0 */ 
  nstud = 0;
  /* Leggiamo una riga del file di input e la scriviamo nella
     nstud-esima riga della matrice elenco utilizzando
     l'istruzione fgets.
     Questa istruzione di lettura la mettiamo all'interno di una
     condizione di esecuzione di un ciclo while(...) {...}.
     Continuiamo ad eseguire il ciclo, mentre e' verificata la
     condizione che il risultato restituito da fgets sia diverso da
     NULL */
  while( fgets(&elenco[nstud][0], 3*LUNGMAX, ifp) != NULL) {
    /* Incrementiamo di 1 la variabile nstud */
    nstud++;
  }
  /* Chiudiamo il file di input */
  fclose(ifp);
  /* LE PROSSIME DUE LINEE DI PROGRAMMA COSTITUISCONO L'UNICA
     VARIAZIONE SIGNIFICATIVA DEL main DI QUESTO PROGRAMMA RISPETTO AL
     main DI QUELLO IN ordina_elenco.c:
     ORA UTILIZZIAMO LO STESSO ALGORITMO DI ORDINAMENTO CHE AVEVAMO
     GIA' SFRUTTATO NEL PROGRAMMA IN inserisci_vettore.c */
  for(n=1; n<nstud; n++)
    riordina(elenco, n);
  /* Apriamo il file di output "ordelenco.dat" in scrittura,
     associamo a ofp l'indirizzo corrispondente al file */
  ofp = fopen("ordelenco.dat", "w");
  /* Scriviamo la riga di intestazione nel file di output */
  fprintf(ofp, intestazione);
  /* Eseguiamo un ciclo sulla variabile intera i in modo
     da considerare tutti gli nstud studenti che fanno parte
     dell'elenco */
  for(i=0; i<nstud; i++) {
    /* Scriviamo sul file di output la i-esima riga della matrice
       elenco */
    fprintf(ofp,"%s", &elenco[i][0]);
  }
  /* Chiudiamo il file di output */
  fclose(ofp);
  exit(0);
}
/* ### */
void riordina(elenco, n)
     char elenco[][3*LUNGMAX];
     int n;
     /* Questa routine mette in ordine non decrescente le prime n+1
	righe della matrice elenco, supposto che che le prime n righe
	siano gia' ordinate */
{
  /* QUESTA FUNZIONE E' DATA DA UNA PICCOLISSIMA VARIAZIONE RISPETTO A
     QUELLA CHE SI TROVA IN inserisci_vettore.c */
  int j, ii;
  ii =  trova_dove_inserire(elenco, n);
  for(j=ii; j<n; j++) {
    /* LA PROSSIMA LINEA DI PROGRAMMA COSTITUISCE L'UNICA VARIAZIONE
       SIGNIFICATIVA RISPETTO ALLA FUNZIONE riordina CHE SI TROVA
       IN inserisci_vettore.c. INFATTI, ORA NON DOBBIAMO ESEGUIRE
       UNO SCAMBIO TRA DUE ELEMENTI DI UN VETTORE, MA TRA DUE RIGHE
       DI UNA MATRICE:
       eseguiamo lo scambio tra la j-esima riga e la n-esima riga
       dell'elenco facendo appello alla routine scambia_righe */
    scambia_righe(elenco, j, n);
  }
}
/* ### */
void scambia_righe(elenco, riga1, riga2)
     char elenco[][3*LUNGMAX];
     int riga1, riga2;
{
  int i;
  char tmp;
  /* QUESTA FUNZIONE E' ESATTAMENTE IDENTICA A QUELLA CHE SI TROVA IN
     ordina_elenco.c */
  /* Eseguiamo il seguente ciclo di istruzioni mentre il contatore
     i va da 0 a 3*LUNGMAX (cioe' consideriamo tutte le colonne
     della matrice elenco) */
  for(i=0;i<3*LUNGMAX;i++) {
    /* Poniamo tmp uguale all'i-esimo elemento di colonna della
       riga1-esima riga della matrice elenco */
    tmp = elenco[riga1][i];
    /* Poniamo l'i-esimo elemento di colonna della riga1-esima riga
       della matrice elenco uguale all'i-esimo elemento di colonna
       della riga2-esima riga della stessa matrice elenco */
    elenco[riga1][i] = elenco[riga2][i];
    /* Poniamo l'i-esimo elemento di colonna della riga2-esima riga
       della matrice elenco uguale a tmp */
    elenco[riga2][i] = tmp;
  }
}
/* ### */
int trova_dove_inserire(elenco, n)
     char elenco[][3*LUNGMAX];
     int n;
     /* Se le righe di matrice elenco[0][], ... , elenco[n-1][] (dove
	e' stata utilizzata la scrittura simbolica elenco[i][], CHE
	NON HA NESSUN SENSO IN LINGUAGGIO C, per denotare tutta la
	i-esima riga di elenco) sono ordinate in modo non decrescente
	(rispetto al login name: vedi sotto), la presente routine
	restituisce il valore i dell'indice in cui deve essere
	inserita la riga elenco[n][] affinche' le prime n+1 righe di
	elenco siano ordinate in modo non decrescente, cioe' il
	corretto ordinamento sara'
          elenco[0][], ... , elenco[i-1][], elenco[n][],
	  elenco[i][], ... , elenco[n-1][] */
{
  int iei, ies, im;
  /* QUESTA FUNZIONE E' DATA DA UNA PICCOLISSIMA VARIAZIONE RISPETTO A
     QUELLA CHE SI TROVA IN inserisci_vettore.c.
     PIU' PRECISAMENTE, LA VARIAZIONE E' PRESENTE IN TUTTE E SOLE
     LE ISTRUZIONI CON UN TEST if:
     IN QUESTO PROGRAMMA NON DOBBIAMO FARE SOLO IL CONFRONTO TRA DUE
     ELEMENTI DI VETTORE (COME IN inserisci_vettore.c), INVECE
     DOBBIAMO CONFRONTARE DUE COPPIE DI ELEMENTI DELLA MATRICE elenco.
     INFATTI, SICCOME VOGLIAMO FARE UN ORDINAMENTO RISPETTO AL LOGIN
     NAME (CHE E' DEL TIPO lpmatxy DOVE x E y SONO DUE CIFRE) GLI
     ELEMENTI SIGNIFICATIVI PER EFFETTUARE IL CONFRONTO SONO QUELLI
     NELLE COLONNE 5 E 6 DI CIASCUNA RIGA */
  if( (elenco[n][5] < elenco[0][5]) ||
      (elenco[n][5] == elenco[0][5] && elenco[n][6] < elenco[0][6]) )
    return(0);
  if( (elenco[n][5] > elenco[n-1][5]) ||
      (elenco[n][5] == elenco[n-1][5] && elenco[n][6] > elenco[n-1][6]) )
    return(n);
  iei = 0;
  ies = n-1;
  while(ies > iei+1) {
    im = (iei + ies) / 2;
    if( (elenco[n][5] < elenco[im][5]) ||
	(elenco[n][5] == elenco[im][5] && elenco[n][6] < elenco[im][6]) )
      ies = im;
    else
      iei = im;
  }
  return(ies);
}
