#include <stdio.h>
/* inserisci_vettore.c : file sorgente di un programma che mette in
                         ordine non decrescente gli elementi (di tipo
                         char) di un vettore nel seguente modo.
			 Per prima cosa viene effettuato un
                         riordinamento sui primi due elementi; poi si
                         trova dove deve essere inserito il terzo
                         elemento nel vettore formato dai primi tre
                         elementi, affinche' sia rispettato l'ordine, e
                         quindi vengono riordinati i primi tre
                         elementi grazie a degli scambi; poi si trova
                         dove deve essere inserito il quarto elemento
                         nel vettore formato dai primi quattro
                         elementi, affinche' sia rispettato l'ordine,
                         etc.
			 A ogni passo dell'algoritmo, l'indice del
			 posto in cui deve essere inserito il nuovo
			 elemento viene determinato grazie a una
			 ricerca di tipo binario. */
/* ### */
/* La prossima definizione consente di cambiare facilmente il numero
   degli elementi del vettore che verra' riordinato */
#define NMAX 15
/* Definizione dei prototipi delle funzioni */
void riordina(char vet[], int n);
int trova_dove_inserire(char vet[], int n);
void stampa_vettore(char vet[]);
/* ### */
int main()
{
  int n;
  char vet[NMAX] = {12, 15, 13, 30, 19, 24, 7, 35, 2, 23, 1, 4, 41, 36, 3};
  printf("  Stampa degli elementi del vettore prima del riordinamento:\n");
  stampa_vettore(vet);
  for(n=1; n<NMAX; n++)
    riordina(vet, n);
  printf("  Stampa degli elementi del vettore dopo il riordinamento:\n");
  stampa_vettore(vet);
  exit(0);
}
/* ### */
void riordina(vet, n)
     char vet[];
     int n;
     /* Questa routine mette in ordine non decrescente i primi n+1
	elementi del vettore vet, supposto che che i primi n elementi
	siano gia' ordinati */
{
  char tmp;
  int j, ii;
  ii =  trova_dove_inserire(vet, n);
  for(j=ii; j<n; j++) {
    tmp = vet[j];
    vet[j] = vet[n];
    vet[n] = tmp;
  }
}
/* ### */
int trova_dove_inserire(vet, n)
     char vet[];
     int n;
     /* Se gli elementi di vettore vet[0], ... , vet[n-1] sono
	ordinati in modo non decrescente, la presente routine
	restituisce il valore i dell'indice in cui deve essere
	inserito l'elemento vet[n] affinche' i primi n+1 elementi di
	vet siano ordinati in modo non decrescente, cioe' il corretto
	ordinamento sara'
          vet[0], ... , vet[i-1], vet[n], vet[i], ... , vet[n-1] */
{
  int iei, ies, im;
  if(vet[n] < vet[0])
    return(0);
  if(vet[n] >= vet[n-1])
    return(n);
  iei = 0;
  ies = n-1;
  while(ies > iei+1) {
    im = (iei + ies) / 2;
    if(vet[n] < vet[im])
      ies = im;
    else
      iei = im;
  }
  return(ies);
}
/* ### */
void stampa_vettore(vet)
     char vet[];
{
  int i;
  for(i=0; i<NMAX; i++) {
    printf("%5d", vet[i]);
    if((i+1)%5 == 0)  printf("\n");
  }
  printf("\n");
}
