#include <stdio.h>
#include <math.h>
/* quoz_polinomi.c : file sorgente di un programma che esegue
                     la divisione tra polinomi a coefficienti interi. */
/* ### */
/* La prossima definizione consente di cambiare facilmente il grado
   massimo che puo' assumere i polinomi che vengono rappresentati
   dal programma. */
#define GRADOMAX 10
/* Definizione dei prototipi delle funzioni */
void aggiungi_primo_polinomio_al_secondo(int grado_pol1, int vet_pol1[],
					 int *grado_pol2, int vet_pol2[]);
void divisione_polinomiale(int grado_pol, int vet_pol[], int grado_divis,
			   int vet_divis[], int *grado_quoz, int vet_quoz[],
			   int *grado_resto, int vet_resto[]);
void prodotto_per_potenza_x(int grado_pol, int vet_pol[], int exp_x,
			    int *grado_ris, int vet_ris[]);
void prodotto_per_scalare(int *grado_pol, int vet_pol[], int coef);
void stampa_polinomio(int grado_pol, int vet_pol[]);
/* ### */
int main()
{
  int i, grado_p, vet_p[GRADOMAX+1], grado_d, vet_d[GRADOMAX+1];
  int grado_q, vet_q[GRADOMAX+1], grado_r, vet_r[GRADOMAX+1];
  int grado_a, vet_a[GRADOMAX+1], exp_x;
  int coef;
  /* Input della variabile grado_p (cioe' il grado del polinomio P(x)) */ 
  do {
    printf("Grado del polinomio P(x)? (deve essere >=-1 e <=%d)\n", GRADOMAX);
    scanf("%d", &grado_p);
  } while(grado_p<-1 || grado_p>GRADOMAX);
  if(grado_p == -1) {
    printf("Quando il grado e' negativo s'intende che il polinomio sia = 0\n");
  }
  else {
    printf("  -- Inizio inserimento dei coefficienti del polinomio P(x) --\n");
    /* Eseguiamo il ciclo di istruzioni seguente per i compreso tra 0 e
       grado_p-1 */
    for(i=0; i<grado_p; i++) {
      /* Input di vet_p[i] (cioe' del coefficiente relativo al termine
	 x^i) */
      printf("Coefficiente intero relativo al termine x^%d ?  ", i);
      scanf("%d", &vet_p[i]);
    }
    do {
      printf("Coefficiente intero relativo al termine x^%d ?\n",grado_p);
      printf("(deve essere diverso da 0, e' il termine di grado massimo!)\n");
      scanf("%d", &vet_p[grado_p]);
    } while(vet_p[grado_p]==0);
    printf("  -- Fine inserimento dei coefficienti del polinomio P(x) --\n");
  }
  printf("  Prova di stampa del polinomio P(x):\n");
  printf("P(x) = ");
  stampa_polinomio(grado_p, vet_p);
  printf("\n\n");
  /* Attenzione!!!
     Se non si vuole appesantire troppo la parte di programma scritta
     nel main e l'output del programma stesso, si possono togliere
     tutte le istruzioni a cominciare da quella che segue fino
     all'input del grado del polinomio D(x).
     Tutte queste istruzioni sono state scritte per agevolare la
     fase di test del programma passo per passo */
  do {
    printf("Inserire un coefficiente intero (deve essere >=0 e <=%d) per\n",
	   GRADOMAX-grado_p);
    printf("effettuare la moltiplicazione per una potenza di x:\n");
    scanf("%d", &exp_x);
  } while(exp_x<0 || exp_x>GRADOMAX-grado_p);
  printf("  Prova di moltiplicazione per una potenza di x:\n");
  prodotto_per_potenza_x(grado_p, vet_p, exp_x, &grado_a, vet_a);
  printf("A(x) = x^%d * P(x) = ", exp_x);
  stampa_polinomio(grado_a, vet_a);
  printf("\n\n");
  printf("Inserire un coefficiente intero per effettuare\n");
  printf("la moltiplicazione per uno scalare:\n");
  scanf("%d", &coef);
  printf("  Prova di moltiplicazione per scalare:\n");
  prodotto_per_scalare(&grado_a, vet_a, coef);
  printf("A(x) = %d * x^%d * P(x) = ", coef, exp_x);
  stampa_polinomio(grado_a, vet_a);
  printf("\n\n");
  /* Input della variabile grado_d (cioe' il grado del polinomio D(x)) */ 
  do {
    printf("Grado del polinomio D(x)? (deve essere >=-1 e <=%d)\n", GRADOMAX);
    scanf("%d", &grado_d);
  } while(grado_d<-1 || grado_d>GRADOMAX);
  if(grado_d == -1) {
    printf("Quando il grado e' negativo s'intende che il polinomio sia = 0\n");
  }
  else {
    printf("  -- Inizio inserimento dei coefficienti del polinomio D(x) --\n");
    /* Eseguiamo il ciclo di istruzioni seguente per i compreso tra 0 e
       grado_d-1 */
    for(i=0; i<grado_d; i++) {
      /* Input di vet_d[i] (cioe' del coefficiente relativo al termine
	 x^i) */
      printf("Coefficiente intero relativo al termine x^%d ?  ", i);
      scanf("%d", &vet_d[i]);
    }
    printf("Il coefficiente intero relativo al termine x^%d ", grado_d);
    printf("e' automaticamente\ndefinito uguale a 1, perche' questo e' ");
    printf("il caso in cui la divisione\ntra polinomi a coefficienti interi ");
    printf("da sempre quoziente e resto\nche sono ancora ");
    printf("polinomi a coefficienti interi\n");
    vet_d[grado_d] = 1;
    printf("  -- Fine inserimento dei coefficienti del polinomio D(x) --\n");
  }
  printf("  Prova di stampa del polinomio D(x):\n");
  printf("D(x) = ");
  stampa_polinomio(grado_d, vet_d);
  printf("\n\n");
  /* Attenzione!!!
     Se non si vuole appesantire troppo la parte di programma scritta
     nel main e l'output del programma stesso, si possono togliere
     tutte le istruzioni a cominciare da quella che segue fino
     all'inizio della prova di divisione polinomiale.
     Tutte queste istruzioni sono state scritte per agevolare la
     fase di test del programma passo per passo */
  printf("  Prova di somma di un primo polinomio a un secondo:\n");
  aggiungi_primo_polinomio_al_secondo(grado_d, vet_d, &grado_a, vet_a);
  printf("A(x) + D(x) = ");
  stampa_polinomio(grado_a, vet_a);
  printf("\n\n");
  printf("  Prova di divisione polinomiale:\n");
  divisione_polinomiale(grado_p, vet_p, grado_d, vet_d,
			&grado_q, vet_q, &grado_r, vet_r);
  printf("P(x) = D(x) * Q(x) + R(x) ,\n");
  printf("  dove\n");
  printf("P(x) = ");
  stampa_polinomio(grado_p, vet_p);
  printf("D(x) = ");
  stampa_polinomio(grado_d, vet_d);
  printf("Q(x) = ");
  stampa_polinomio(grado_q, vet_q);
  printf("R(x) = ");
  stampa_polinomio(grado_r, vet_r);
  printf("\n\n");
  exit(0);
}
/* ### */
void aggiungi_primo_polinomio_al_secondo(grado_pol1, vet_pol1,
					 grado_pol2, vet_pol2)
     int grado_pol1, vet_pol1[], *grado_pol2, vet_pol2[];
     /* Nota: per semplicita' si assume che quando la funzione
	      viene chiamata il grado del secondo polinomio
	      e' maggiore o uguale a quello del primo */
{
  int i;
  /* Effettuiamo un test per verificare se il coefficiente del
     primo polinomio e' maggiore di quello del secondo ... */
  if(grado_pol1 > *grado_pol2) {
    /* ... Questa function non contempla questo caso, che potrebbe
       generare degli errori.
       Allora stampiamo un messaggio di errore e usciamo dalla
       function */
    printf("Il grado del primo polinomio (quello che viene aggiunto)\n");
    printf("deve essere <= a quello del secondo polinomio!!!!\n");
    return;
  }
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     grado_pol1 */
  for(i=0; i<=grado_pol1; i++) {
    /* Al coefficiente del termine di grado i del secondo polinomio
       deve essere aggiunto il coefficiente del termine dello stesso
       grado del primo polinomio */
    vet_pol2[i] += vet_pol1[i];
  }
  /* Aggiornamento del grado del secondo polinomio:
     eseguiamo il ciclo di istruzioni seguenti per i che va dal grado
     del secondo polinomio fino a 0 (a ritroso) */
  for(i=*grado_pol2; i>=0; i--) {
    /* Effettuiamo un test per verificare se il coefficiente del
       termine di grado i del secondo polinomio e' uguale a zero ... */
    if(vet_pol2[i] == 0) {
      /* ... Allora il grado del secondo polinomio deve essere
	 decrementato di 1 */
      (*grado_pol2)--;
    }
    else {
      /* ... Altrimenti usciamo dal ciclo sul contatore i con
	 un'istruzione break  */
      break;
    }
  }
}
/* ### */
void divisione_polinomiale(grado_pol, vet_pol, grado_divis, vet_divis,
			   grado_quoz, vet_quoz, grado_resto, vet_resto)
     int grado_pol, vet_pol[], grado_divis, vet_divis[];
     int *grado_quoz, vet_quoz[], *grado_resto, vet_resto[];
{
  int i, grado_add, vet_add[GRADOMAX];
  /* Uguagliamo il resto al polinomio dividendo (il primo nella lista
     degli argomenti);
     per prima cosa uguagliamo il grado dei polinomi ... */
  *grado_resto = grado_pol;
  /* ... poi eseguiamo il ciclo di istruzioni seguenti per i che va da
     0 a grado_pol */
  for(i=0; i<=grado_pol; i++) {
    /* Uguagliamo il coefficiente del termine di grado i del polinomio
       resto a quello corrispondente del polinomio dividendo */
    vet_resto[i] = vet_pol[i];
  }
  /* Effettuiamo un test per verificare se il grado del polinomio
     divisore e' maggiore di quello del polinomio dividendo ... */
  if(grado_divis > grado_pol) {
    /* ... Allora poniamo il polinomio quoziente uguale a 0 (basta
       porre il grado pel polinomio quoziente uguale a -1) */
    *grado_quoz = -1;
    /* A questo punto la divisione e' gia' terminata: usciamo dalla
       function */
    return;
  }
  /* Poniamo il grado del polinomio quoziente uguale al grado
     del polinomio dividendo meno quello del polinomio divisore */
  *grado_quoz = grado_pol - grado_divis;
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va dal grado
     del polinomio quoziente fino a 0 (a ritroso) */
  for(i=*grado_quoz; i>=0; i--) {
    /* Poniamo (temporaneamente) il polinomio addendo uguale
       al polinomio divisore moltiplicato per x elevato alla i */
    prodotto_per_potenza_x(grado_divis, vet_divis, i, &grado_add, vet_add);
    /* Poniamo il coefficiente del termine di grado i del polinomio
       quoziente uguale al coefficiente del termine di grado i + il
       grado del polinomio divisore */
    vet_quoz[i] = vet_resto[i+grado_divis];
    /* Moltiplichiamo il polinomio addendo per meno il coefficiente
       del termine grado i del polinomio quoziente */
    prodotto_per_scalare(&grado_add, vet_add, -vet_quoz[i]);
    /* Aggiungiamo il polinomio addendo al polinomio resto */
    aggiungi_primo_polinomio_al_secondo(grado_add, vet_add,
					grado_resto, vet_resto);
  }
}
/* ### */
void prodotto_per_potenza_x(grado_pol, vet_pol, exp_x, grado_ris, vet_ris)
     int grado_pol, vet_pol[], exp_x, *grado_ris, vet_ris[];
{
  int i;
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     grado_pol */
  for(i=0; i<=grado_pol; i++) {
    /* Il coefficiente del termine di grado i+exp_x del polinomio
       risultato e' uguale al coefficiente del termine di grado i
       del polinomio rappresentato dal vettore vet_pol */
    vet_ris[i+exp_x] = vet_pol[i];
  }
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     exp_x-1 */
  for(i=0; i<exp_x; i++) {
    /* Azzeriamo il coefficiente del termine di grado i del polinomio
       risultato */
    vet_ris[i] = 0;
  }
  /* Calcolo del grado del polinomio risultato:
     effettuiamo un test per verificare se grado_pol e' minore
     di zero ... */
  if(grado_pol < 0) {
    /* ... Allora il polinomio rappresentato dal vettore vet_pol e'
       uguale a 0, quindi sara' zero anche il polinomio risultato,
       dunque poniamo il grado del polinomio risultato uguale a -1 */
    *grado_ris = -1;
  }
  else {
    /* ... Altrimenti il grado del polinomio risultato sara' uguale
       alla somma del grado del polinomio rappresentato dal vettore
       vet_pol piu' l'esponente di x */
    *grado_ris = grado_pol + exp_x;
  }
}
/* ### */
void prodotto_per_scalare(grado_pol, vet_pol, coef)
     int *grado_pol, vet_pol[], coef;
{
  int i;
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da 0 a
     grado_pol */
  for(i=0; i<=*grado_pol; i++) {
    /* Il coefficiente del termine di grado i del polinomio deve
       essere moltiplicato per il numero coef  */
    vet_pol[i] *= coef;
  }
  /* Aggiornamento del grado del polinomio risultato:
     effettuiamo un test per verificare se coef e' uguale a zero ... */
  if(coef == 0) {
    /* ... Allora il polinomio e' diventato uguale a zero, quindi
       poniamo il suo grado uguale a -1 */    
    *grado_pol = -1;
  }
}
/* ### */
void stampa_polinomio(grado_pol, vet_pol)
     int grado_pol, vet_pol[];
{
  int i;
  /* Eseguiamo il ciclo di istruzioni seguenti per i che va da grado_p
     fino a 0 (a ritroso) */
  for(i=grado_pol; i>=0; i--) {
    /* Effettuiamo un test per verificare se P(x) il coefficiente del
       termine di grado i e' diverso da zero, altrimenti non dobbiamo
       fare nulla e decrementiamo i */
    if(vet_pol[i] != 0) {
      /* Effettuiamo un test per verificare se i e' minore di grado_pol
	 ... */
      if(i < grado_pol) {
	/* ... Allora se il coefficiente del termine di grado i e'
	   positivo dobbiamo stampare " +" ... */
	if(vet_pol[i] > 0)
	  printf(" +");
	/* ... Altrimenti stampiamo solo uno spazio*/
	else
	  printf(" ");
      }
      /* Effettuiamo un test per verificare se il grado i e' uguale
	 a zero ... */
      if(i == 0) {
	/* ... Allora stampiamo il coefficiente e nient'altro */
	printf("%d", vet_pol[i]);
      }
      /* ... Altrimenti se i e' diverso da zero ...*/
      else {
	/* stampiamo il coefficiente (seguito da un simbolo *) solo se
	   il coefficiente e' diverso da 1 */
	if(vet_pol[i] != 1)
	  printf("%d*", vet_pol[i]);
	/* Adesso stampiamo la potenza i-esima di x */
	printf("x^%d", i);
      }
    }
  }
  /* Osservazione: se grado_pol < 1, nel ciclo di istruzioni
     precedenti sul contatore i non e' stato stampato niente.
     Effettuiamo un test per verificare se grado_pol e' minore
     di 0 ...*/
  if(grado_pol < 0) {
    /* ... Allora stampiamo semplicemente uno 0 */
    printf("0");
  }
  /* Stampiamo un ritorno a capo riga */
  printf("\n");
}
